/*
 * example of fork() system call
 */

#include <stdio.h>

int main(int argc, char *argv)
{
  short child_pid;

  // Withouth the fflush, this printf will cause something funny to happen.
  printf("Calling fork()...");  fflush(stdout);

  child_pid = fork();
  if (child_pid < 0) {
    printf("fork failed.\n");
  }

  if (child_pid == 0) {
    printf("I'm the child. child_pid is %d.\n", child_pid);
  } else if (child_pid != 0) {
    printf("I'm the parent. child_pid is %d.\n", child_pid);
  }
  printf("Process %d finishing\n", getpid());
}
